commit 3fe6135b62f190921db6dcae7bc2f9582ca4e7c2
Author: Marek Polacek <polacek@redhat.com>
Date:   Tue Sep 3 13:04:09 2024 -0400

    c++: noexcept and pointer to member function type [PR113108]
    
    We ICE in nothrow_spec_p because it got a DEFERRED_NOEXCEPT.
    This DEFERRED_NOEXCEPT was created in implicitly_declare_fn
    when declaring
    
      Foo& operator=(Foo&&) = default;
    
    in the test.  The problem is that in resolve_overloaded_unification
    we call maybe_instantiate_noexcept before try_one_overload only in
    the TEMPLATE_ID_EXPR case.
    
            PR c++/113108
    
    gcc/cp/ChangeLog:
    
            * pt.cc (resolve_overloaded_unification): Call
            maybe_instantiate_noexcept.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/cpp1z/noexcept-type28.C: New test.
    
    (cherry picked from commit c755c7a32590e2eef5a8b062b9756c1513910246)

diff --git a/gcc/cp/pt.cc b/gcc/cp/pt.cc
index 4f83426fb56..c2c66a7567a 100644
--- a/gcc/cp/pt.cc
+++ b/gcc/cp/pt.cc
@@ -23799,6 +23799,8 @@ resolve_overloaded_unification (tree tparms,
     for (lkp_iterator iter (arg); iter; ++iter)
       {
 	tree fn = *iter;
+	if (flag_noexcept_type)
+	  maybe_instantiate_noexcept (fn, tf_none);
 	if (try_one_overload (tparms, targs, tempargs, parm, TREE_TYPE (fn),
 			      strict, sub_strict, addr_p, explain_p)
 	    && (!goodfn || !decls_match (goodfn, fn)))
diff --git a/gcc/testsuite/g++.dg/cpp1z/noexcept-type28.C b/gcc/testsuite/g++.dg/cpp1z/noexcept-type28.C
new file mode 100644
index 00000000000..bf0b927b8ec
--- /dev/null
+++ b/gcc/testsuite/g++.dg/cpp1z/noexcept-type28.C
@@ -0,0 +1,18 @@
+// PR c++/113108
+// { dg-do compile { target c++17 } }
+
+template <typename T>
+struct Foo {
+    Foo& operator=(Foo&&) = default;
+    T data;
+};
+
+template <typename T>
+void consume(Foo<T>& (Foo<T>::*)(Foo<T>&&) ) {}
+
+template <typename T>
+void consume(Foo<T>& (Foo<T>::*)(Foo<T>&&) noexcept) {}
+
+int main() {
+    consume(&Foo<int>::operator=);
+}

